VirtualBox

source: vbox/trunk/src/VBox/Additions/linux/installer/vboxadd.sh@ 57945

Last change on this file since 57945 was 57945, checked in by vboxsync, 10 years ago

Installers/linux: cleaned up init script output and logging a bit.

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
  • Property svn:keywords set to Author Date Id Revision
File size: 14.4 KB
Line 
1#! /bin/sh
2#
3# Linux Additions kernel module init script ($Revision: 57945 $)
4#
5
6#
7# Copyright (C) 2006-2012 Oracle Corporation
8#
9# This file is part of VirtualBox Open Source Edition (OSE), as
10# available from http://www.virtualbox.org. This file is free software;
11# you can redistribute it and/or modify it under the terms of the GNU
12# General Public License (GPL) as published by the Free Software
13# Foundation, in version 2 as it comes in the "COPYING" file of the
14# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
15# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
16#
17
18
19# chkconfig: 345 30 70
20# description: VirtualBox Linux Additions kernel modules
21#
22### BEGIN INIT INFO
23# Provides: vboxadd
24# Required-Start:
25# Required-Stop:
26# Default-Start: 2 3 4 5
27# Default-Stop: 0 1 6
28# Description: VirtualBox Linux Additions kernel modules
29### END INIT INFO
30
31PATH=$PATH:/bin:/sbin:/usr/sbin
32PACKAGE=VBoxGuestAdditions
33LOG="/var/log/vboxadd-install.log"
34MODPROBE=/sbin/modprobe
35OLDMODULES="vboxguest vboxadd vboxsf vboxvfs vboxvideo"
36SCRIPTNAME=vboxadd
37
38if $MODPROBE -c 2>/dev/null | grep -q '^allow_unsupported_modules *0'; then
39 MODPROBE="$MODPROBE --allow-unsupported-modules"
40fi
41
42# Check architecture
43cpu=`uname -m`;
44case "$cpu" in
45 i[3456789]86|x86)
46 cpu="x86"
47 lib_candidates="/usr/lib/i386-linux-gnu /usr/lib /lib"
48 ;;
49 x86_64|amd64)
50 cpu="amd64"
51 lib_candidates="/usr/lib/x86_64-linux-gnu /usr/lib64 /usr/lib /lib64 /lib"
52 ;;
53esac
54for i in $lib_candidates; do
55 if test -d "$i/VBoxGuestAdditions"; then
56 lib_path=$i
57 break
58 fi
59done
60
61# Preamble for Gentoo
62if [ "`which $0`" = "/sbin/rc" ]; then
63 shift
64fi
65
66begin()
67{
68 test -n "${2}" && echo "${SCRIPTNAME}: ${1}."
69 logger "${SCRIPTNAME}: ${1}."
70}
71
72succ_msg()
73{
74 logger "${SCRIPTNAME}: done."
75}
76
77fail_msg()
78{
79 echo "${SCRIPTNAME}: failed." >&2
80 logger "${SCRIPTNAME}: failed."
81}
82
83show_error()
84{
85 echo "${SCRIPTNAME}: failed: ${1}." >&2
86 logger "${SCRIPTNAME}: ${1}."
87}
88
89fail()
90{
91 show_error "$1"
92 exit 1
93}
94
95dev=/dev/vboxguest
96userdev=/dev/vboxuser
97config=/var/lib/VBoxGuestAdditions/config
98owner=vboxadd
99group=1
100
101test_for_gcc_and_make()
102{
103 which make > /dev/null 2>&1 || printf "\nThe make utility was not found. If the following module compilation fails then\nthis could be the reason and you should try installing it.\n"
104 which gcc > /dev/null 2>&1 || printf "\nThe gcc utility was not found. If the following module compilation fails then\nthis could be the reason and you should try installing it.\n"
105}
106
107test_sane_kernel_dir()
108{
109 KERN_VER=`uname -r`
110 KERN_DIR="/lib/modules/$KERN_VER/build"
111 if [ -d "$KERN_DIR" ]; then
112 KERN_REL=`make -sC $KERN_DIR --no-print-directory kernelrelease 2>/dev/null || true`
113 if [ -z "$KERN_REL" -o "x$KERN_REL" = "x$KERN_VER" ]; then
114 return 0
115 fi
116 fi
117 printf "\nThe headers for the current running kernel were not found. If the following\nmodule compilation fails then this could be the reason.\n"
118 if which yum >/dev/null; then
119 if echo "$KERN_VER" | grep -q "uek"; then
120 printf "The missing package can be probably installed with\nyum install kernel-uek-devel-$KERN_VER\n"
121 else
122 printf "The missing package can be probably installed with\nyum install kernel-devel-$KERN_VER\n"
123 fi
124 elif which zypper >/dev/null; then
125 KERN_VER_SUSE=`echo "$KERN_VER" | sed 's/.*-\([^-]*\)/\1/g'`
126 KERN_VER_BASE=`echo "$KERN_VER" | sed 's/\(.*\)-[^-]*/\1/g'`
127 printf "The missing package can be probably installed with\nzypper install kernel-$KERN_VER_SUSE-devel-$KERN_VER_BASE\n"
128 elif which apt-get >/dev/null; then
129 printf "The missing package can be probably installed with\napt-get install linux-headers-$KERN_VER\n"
130 fi
131}
132
133running_vboxguest()
134{
135 lsmod | grep -q "vboxguest[^_-]"
136}
137
138running_vboxadd()
139{
140 lsmod | grep -q "vboxadd[^_-]"
141}
142
143running_vboxsf()
144{
145 lsmod | grep -q "vboxsf[^_-]"
146}
147
148running_vboxvideo()
149{
150 lsmod | grep -q "vboxvideo[^_-]"
151}
152
153do_vboxguest_non_udev()
154{
155 if [ ! -c $dev ]; then
156 maj=`sed -n 's;\([0-9]\+\) vboxguest;\1;p' /proc/devices`
157 if [ ! -z "$maj" ]; then
158 min=0
159 else
160 min=`sed -n 's;\([0-9]\+\) vboxguest;\1;p' /proc/misc`
161 if [ ! -z "$min" ]; then
162 maj=10
163 fi
164 fi
165 test -z "$maj" && {
166 rmmod vboxguest 2>/dev/null
167 fail "Cannot locate the VirtualBox device"
168 }
169
170 mknod -m 0664 $dev c $maj $min || {
171 rmmod vboxguest 2>/dev/null
172 fail "Cannot create device $dev with major $maj and minor $min"
173 }
174 fi
175 chown $owner:$group $dev 2>/dev/null || {
176 rm -f $dev 2>/dev/null
177 rm -f $userdev 2>/dev/null
178 rmmod vboxguest 2>/dev/null
179 fail "Cannot change owner $owner:$group for device $dev"
180 }
181
182 if [ ! -c $userdev ]; then
183 maj=10
184 min=`sed -n 's;\([0-9]\+\) vboxuser;\1;p' /proc/misc`
185 if [ ! -z "$min" ]; then
186 mknod -m 0666 $userdev c $maj $min || {
187 rm -f $dev 2>/dev/null
188 rmmod vboxguest 2>/dev/null
189 fail "Cannot create device $userdev with major $maj and minor $min"
190 }
191 chown $owner:$group $userdev 2>/dev/null || {
192 rm -f $dev 2>/dev/null
193 rm -f $userdev 2>/dev/null
194 rmmod vboxguest 2>/dev/null
195 fail "Cannot change owner $owner:$group for device $userdev"
196 }
197 fi
198 fi
199}
200
201start()
202{
203 begin "Starting the VirtualBox Guest Additions" console;
204 uname -r | grep -q -E '^2\.6|^3|^4' 2>/dev/null &&
205 ps -A -o comm | grep -q '/*udevd$' 2>/dev/null ||
206 no_udev=1
207 running_vboxguest || {
208 rm -f $dev || {
209 fail "Cannot remove $dev"
210 }
211
212 rm -f $userdev || {
213 fail "Cannot remove $userdev"
214 }
215
216 $MODPROBE vboxguest >/dev/null 2>&1 || {
217 fail "modprobe vboxguest failed"
218 }
219 case "$no_udev" in 1)
220 sleep .5;;
221 esac
222 }
223 case "$no_udev" in 1)
224 do_vboxguest_non_udev;;
225 esac
226
227 running_vboxsf || {
228 $MODPROBE vboxsf > /dev/null 2>&1 || {
229 if dmesg | grep "vboxConnect failed" > /dev/null 2>&1; then
230 fail_msg
231 echo "Unable to start shared folders support. Make sure that your VirtualBox build"
232 echo "supports this feature."
233 exit 1
234 fi
235 fail "modprobe vboxsf failed"
236 }
237 }
238
239 # This is needed as X.Org Server 1.13 does not auto-load the module.
240 running_vboxvideo || $MODPROBE vboxvideo > /dev/null 2>&1
241
242 # Mount all shared folders from /etc/fstab. Normally this is done by some
243 # other startup script but this requires the vboxdrv kernel module loaded.
244 # This isn't necessary anymore as the vboxsf module is autoloaded.
245 # mount -a -t vboxsf
246
247 succ_msg
248 return 0
249}
250
251stop()
252{
253 begin "Stopping VirtualBox Additions" console;
254 if ! umount -a -t vboxsf 2>/dev/null; then
255 fail "Cannot unmount vboxsf folders"
256 fi
257 if running_vboxsf; then
258 rmmod vboxsf 2>/dev/null || fail "Cannot unload module vboxsf"
259 fi
260 if running_vboxguest; then
261 rmmod vboxguest 2>/dev/null || fail "Cannot unload module vboxguest"
262 rm -f $userdev || fail "Cannot unlink $userdev"
263 rm -f $dev || fail "Cannot unlink $dev"
264 fi
265 succ_msg
266 return 0
267}
268
269restart()
270{
271 stop && start
272 return 0
273}
274
275# Remove any existing VirtualBox guest kernel modules from the disk, but not
276# from the kernel as they may still be in use
277cleanup_modules()
278{
279 if [ -n "$(which dkms 2>/dev/null)" ]; then
280 begin "Removing existing VirtualBox DKMS kernel modules"
281 $DODKMS uninstall $OLDMODULES > $LOG
282 succ_msg
283 fi
284 begin "Removing existing VirtualBox non-DKMS kernel modules"
285 for i in $OLDMODULES; do
286 find /lib/modules -name $i\* | xargs rm 2>/dev/null
287 done
288 succ_msg
289}
290
291# Build and install the VirtualBox guest kernel modules
292setup_modules()
293{
294 # don't stop the old modules here -- they might be in use
295 cleanup_modules
296 begin "Building the VirtualBox Guest Additions kernel modules"
297
298 # Short cut out if a dkms build succeeds
299 if [ -n "$(which dkms 2>/dev/null)" ] &&
300 $DODKMS install vboxguest $INSTALL_VER >> $LOG 2>&1; then
301 succ_msg
302 return 0
303 fi
304
305 test_for_gcc_and_make
306 test_sane_kernel_dir
307
308 echo
309 begin "Building the main Guest Additions module"
310 if ! $BUILDINTMP \
311 --save-module-symvers /tmp/vboxguest-Module.symvers \
312 --module-source $MODULE_SRC/vboxguest \
313 --no-print-directory install >> $LOG 2>&1; then
314 show_error "Look at $LOG to find out what went wrong"
315 return 1
316 fi
317 succ_msg
318 begin "Building the shared folder support module"
319 if ! $BUILDINTMP \
320 --use-module-symvers /tmp/vboxguest-Module.symvers \
321 --module-source $MODULE_SRC/vboxsf \
322 --no-print-directory install >> $LOG 2>&1; then
323 show_error "Look at $LOG to find out what went wrong"
324 return 1
325 fi
326 succ_msg
327 if expr `uname -r` '<' '2.6.27' > /dev/null; then
328 echo "Not building the VirtualBox advanced graphics driver as this Linux version is"
329 echo "too old to use it."
330 else
331 begin "Building the OpenGL support module"
332 if ! $BUILDINTMP \
333 --use-module-symvers /tmp/vboxguest-Module.symvers \
334 --module-source $MODULE_SRC/vboxvideo \
335 --no-print-directory install >> $LOG 2>&1; then
336 show_error "Look at $LOG to find out what went wrong. The module is not built but the others are."
337 else
338 succ_msg
339 fi
340 fi
341 depmod
342 return 0
343}
344
345# Do non-kernel bits needed for the kernel modules to work properly (user
346# creation, udev, mount helper...)
347extra_setup()
348{
349 begin "Doing non-kernel setup of the Guest Additions"
350 echo "Creating user for the Guest Additions." >> $LOG
351 # This is the LSB version of useradd and should work on recent
352 # distributions
353 useradd -d /var/run/vboxadd -g 1 -r -s /bin/false vboxadd >/dev/null 2>&1
354 # And for the others, we choose a UID ourselves
355 useradd -d /var/run/vboxadd -g 1 -u 501 -o -s /bin/false vboxadd >/dev/null 2>&1
356
357 # Add a group "vboxsf" for Shared Folders access
358 # All users which want to access the auto-mounted Shared Folders have to
359 # be added to this group.
360 groupadd -r -f vboxsf >/dev/null 2>&1
361
362 # Create udev description file
363 if [ -d /etc/udev/rules.d ]; then
364 echo "Creating udev rule for the Guest Additions kernel module." >> $LOG
365 udev_call=""
366 udev_app=`which udevadm 2> /dev/null`
367 if [ $? -eq 0 ]; then
368 udev_call="${udev_app} version 2> /dev/null"
369 else
370 udev_app=`which udevinfo 2> /dev/null`
371 if [ $? -eq 0 ]; then
372 udev_call="${udev_app} -V 2> /dev/null"
373 fi
374 fi
375 udev_fix="="
376 if [ "${udev_call}" != "" ]; then
377 udev_out=`${udev_call}`
378 udev_ver=`expr "$udev_out" : '[^0-9]*\([0-9]*\)'`
379 if [ "$udev_ver" = "" -o "$udev_ver" -lt 55 ]; then
380 udev_fix=""
381 fi
382 fi
383 ## @todo 60-vboxadd.rules -> 60-vboxguest.rules ?
384 echo "KERNEL=${udev_fix}\"vboxguest\", NAME=\"vboxguest\", OWNER=\"vboxadd\", MODE=\"0660\"" > /etc/udev/rules.d/60-vboxadd.rules
385 echo "KERNEL=${udev_fix}\"vboxuser\", NAME=\"vboxuser\", OWNER=\"vboxadd\", MODE=\"0666\"" >> /etc/udev/rules.d/60-vboxadd.rules
386 fi
387
388 # Put mount.vboxsf in the right place
389 ln -sf "$lib_path/$PACKAGE/mount.vboxsf" /sbin
390 # And an rc file to re-build the kernel modules and re-set-up the X server.
391 ln -sf "$lib_path/$PACKAGE/vboxadd" /sbin/rcvboxadd
392 ln -sf "$lib_path/$PACKAGE/vboxadd-x11" /sbin/rcvboxadd-x11
393 # At least Fedora 11 and Fedora 12 require the correct security context when
394 # executing this command from service scripts. Shouldn't hurt for other
395 # distributions.
396 chcon -u system_u -t mount_exec_t "$lib_path/$PACKAGE/mount.vboxsf" > /dev/null 2>&1
397 # And at least Fedora 15 needs this for the acceleration support check to
398 # work
399 redhat_release=`cat /etc/redhat-release 2> /dev/null`
400 case "$redhat_release" in Fedora\ release\ 15* )
401 for i in "$lib_path"/*.so
402 do
403 restorecon "$i" >/dev/null
404 done
405 ;;
406 esac
407
408 succ_msg
409}
410
411# setup_script
412setup()
413{
414 if test -r $config; then
415 . $config
416 else
417 fail "Configuration file $config not found"
418 fi
419 test -n "$INSTALL_DIR" -a -n "$INSTALL_VER" ||
420 fail "Configuration file $config not complete"
421 export BUILD_TYPE
422 export USERNAME
423
424 MODULE_SRC="$INSTALL_DIR/src/vboxguest-$INSTALL_VER"
425 BUILDINTMP="$MODULE_SRC/build_in_tmp"
426 DODKMS="$MODULE_SRC/do_dkms"
427 chcon -t bin_t "$BUILDINTMP" > /dev/null 2>&1
428 chcon -t bin_t "$DODKMS" > /dev/null 2>&1
429
430 setup_modules
431 mod_succ="$?"
432 extra_setup
433 if [ "$mod_succ" -eq "0" ]; then
434 if running_vboxguest || running_vboxadd; then
435 printf "You should restart your guest to make sure the new modules are actually used\n\n"
436 else
437 start
438 fi
439 fi
440}
441
442# cleanup_script
443cleanup()
444{
445 if test -r $config; then
446 . $config
447 test -n "$INSTALL_DIR" -a -n "$INSTALL_VER" ||
448 fail "Configuration file $config not complete"
449 DODKMS="$INSTALL_DIR/src/vboxguest-$INSTALL_VER/do_dkms"
450 elif test -x ./do_dkms; then # Executing as part of the installer...
451 DODKMS=./do_dkms
452 else
453 fail "Configuration file $config not found"
454 fi
455
456 # Delete old versions of VBox modules.
457 cleanup_modules
458 depmod
459
460 # Remove old module sources
461 for i in $OLDMODULES; do
462 rm -rf /usr/src/$i-*
463 done
464
465 # Remove other files
466 rm /sbin/mount.vboxsf 2>/dev/null
467 rm /sbin/rcvboxadd 2>/dev/null
468 rm /sbin/rcvboxadd-x11 2>/dev/null
469 rm /etc/udev/rules.d/60-vboxadd.rules 2>/dev/null
470}
471
472dmnstatus()
473{
474 if running_vboxguest; then
475 echo "The VirtualBox Additions are currently running."
476 else
477 echo "The VirtualBox Additions are not currently running."
478 fi
479}
480
481case "$1" in
482start)
483 start
484 ;;
485stop)
486 stop
487 ;;
488restart)
489 restart
490 ;;
491setup)
492 setup
493 ;;
494cleanup)
495 cleanup
496 ;;
497status)
498 dmnstatus
499 ;;
500*)
501 echo "Usage: $0 {start|stop|restart|status|setup}"
502 exit 1
503esac
504
505exit
Note: See TracBrowser for help on using the repository browser.

© 2025 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette